\begin{frame}{BHB - Branch History Buffer}{Spectre-BHB}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{description}
                \item[Branch] Describes the correct function of Source and Target.
                \item[F1] Hash Function
                \item[BHB] Buffer to store previously executed branches.   
            \end{description}
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=11cm]{./images/branch-history-buffer.png}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{Branch Context}{Spectre-BHB}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{description}
                \item[BHB] Buffer to store previously executed branches. 
                \item[Branch source address] Actual branch source.
                \item[F2] Branch Context Hash.
            \end{description}
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=7cm]{./images/branch-context.png}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{BTB - Branch Target Buffer}{Spectre-BHB}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{description}
                \item[BTB] Mapping between tag and target.
            \end{description}
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=10cm]{./images/branch-target-buffer.png}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{Branch Prediction}{Spectre-BHB}
    \begin{columns}
        \begin{column}{.4\textwidth}
            \begin{description}
                \item[F2] Branch Context.
                \item[BTB] Mapping between tag and target.
            \end{description}
        \end{column}
        \begin{column}{.4\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=10cm]{./images/branch-prediction.png}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}

\begin{frame}{BPU - Branch Prediction Unit}{Spectre-BHB}
    \begin{columns}
        \begin{column}{.3\textwidth}
            \begin{description}
                \item[F1] Hash Function
                \item[F2] Branch Context Hash (= BTB Tag)
                \item[BHB] Branch History Buffer (globally shared)
                \item[BTB] Branch Target Buffer  (Cache) 
            \end{description}
        \end{column}
        \begin{column}{.7\textwidth}
            \begin{figure}
                \center
                \includegraphics[height=11cm]{./images/branch-prediction-unit.png}    
            \end{figure}
        \end{column}
    \end{columns}
\end{frame}